Index: trunk/src/VBox/Devices/Network/DevE1000.cpp
===================================================================
--- trunk/src/VBox/Devices/Network/DevE1000.cpp	(revision 90331)
+++ trunk/src/VBox/Devices/Network/DevE1000.cpp	(revision 90332)
@@ -3564,5 +3564,5 @@
 {
     PE1KSTATE pThis = (PE1KSTATE)pvUser;
-    Assert(PDMCritSectIsOwner(&pThis->csTx));
+    Assert(PDMDevHlpCritSectIsOwner(pDevIns, &pThis->csTx));
     RT_NOREF(hTimer);
 
Index: trunk/src/VBox/Devices/PC/DevIoApic.cpp
===================================================================
--- trunk/src/VBox/Devices/PC/DevIoApic.cpp	(revision 90331)
+++ trunk/src/VBox/Devices/PC/DevIoApic.cpp	(revision 90332)
@@ -1530,6 +1530,6 @@
      * Destroy the RTE critical section.
      */
-    if (PDMCritSectIsInitialized(&pThis->CritSect))
-        PDMR3CritSectDelete(&pThis->CritSect);
+    if (PDMDevHlpCritSectIsInitialized(pDevIns, &pThis->CritSect))
+        PDMDevHlpCritSectDelete(pDevIns, &pThis->CritSect);
 # else
     RT_NOREF_PV(pThis);
Index: trunk/src/VBox/Devices/Parallel/DevParallel.cpp
===================================================================
--- trunk/src/VBox/Devices/Parallel/DevParallel.cpp	(revision 90331)
+++ trunk/src/VBox/Devices/Parallel/DevParallel.cpp	(revision 90332)
@@ -304,7 +304,7 @@
     PPARALLELPORT   pThis   = PDMDEVINS_2_DATA(pDevIns, PPARALLELPORT);
 
-    PDMCritSectEnter(pDevIns->pCritSectRoR3, VINF_SUCCESS);
+    PDMDevHlpCritSectEnter(pDevIns, pDevIns->pCritSectRoR3, VINF_SUCCESS);
     parallelR3IrqSet(pDevIns, pThis);
-    PDMCritSectLeave(pDevIns->pCritSectRoR3);
+    PDMDevHlpCritSectLeave(pDevIns, pDevIns->pCritSectRoR3);
 
     return VINF_SUCCESS;
Index: trunk/src/VBox/Devices/Serial/UartCore.cpp
===================================================================
--- trunk/src/VBox/Devices/Serial/UartCore.cpp	(revision 90331)
+++ trunk/src/VBox/Devices/Serial/UartCore.cpp	(revision 90332)
@@ -1632,8 +1632,8 @@
 
     /* Set the transmitter empty bit because everything was sent. */
-    PDMCritSectEnter(&pThis->CritSect, VERR_IGNORED);
+    PDMDevHlpCritSectEnter(pDevIns, &pThis->CritSect, VERR_IGNORED);
     UART_REG_SET(pThis->uRegLsr, UART_REG_LSR_TEMT);
     uartIrqUpdate(pDevIns, pThis, pThisCC);
-    PDMCritSectLeave(&pThis->CritSect);
+    PDMDevHlpCritSectLeave(pDevIns, &pThis->CritSect);
     return VINF_SUCCESS;
 }
@@ -1652,7 +1652,7 @@
     AssertReturn(cbRead > 0, VERR_INVALID_PARAMETER);
 
-    PDMCritSectEnter(&pThis->CritSect, VERR_IGNORED);
+    PDMDevHlpCritSectEnter(pDevIns, &pThis->CritSect, VERR_IGNORED);
     uartR3TxQueueCopyFrom(pDevIns, pThis, pThisCC, pvBuf, cbRead, pcbRead);
-    PDMCritSectLeave(&pThis->CritSect);
+    PDMDevHlpCritSectLeave(pDevIns, &pThis->CritSect);
 
     LogFlowFunc(("-> VINF_SUCCESS{*pcbRead=%zu}\n", *pcbRead));
@@ -1671,7 +1671,7 @@
     PPDMDEVINS  pDevIns = pThisCC->pDevIns;
 
-    PDMCritSectEnter(&pThis->CritSect, VERR_IGNORED);
+    PDMDevHlpCritSectEnter(pDevIns, &pThis->CritSect, VERR_IGNORED);
     uartR3StsLinesUpdate(pDevIns, pThis, pThisCC, fNewStatusLines);
-    PDMCritSectLeave(&pThis->CritSect);
+    PDMDevHlpCritSectLeave(pDevIns, &pThis->CritSect);
     return VINF_SUCCESS;
 }
@@ -1688,8 +1688,8 @@
     PPDMDEVINS  pDevIns = pThisCC->pDevIns;
 
-    PDMCritSectEnter(&pThis->CritSect, VERR_IGNORED);
+    PDMDevHlpCritSectEnter(pDevIns, &pThis->CritSect, VERR_IGNORED);
     UART_REG_SET(pThis->uRegLsr, UART_REG_LSR_BI);
     uartIrqUpdate(pDevIns, pThis, pThisCC);
-    PDMCritSectLeave(&pThis->CritSect);
+    PDMDevHlpCritSectLeave(pDevIns, &pThis->CritSect);
     return VINF_SUCCESS;
 }
Index: trunk/src/VBox/Devices/USB/DevOHCI.cpp
===================================================================
--- trunk/src/VBox/Devices/USB/DevOHCI.cpp	(revision 90331)
+++ trunk/src/VBox/Devices/USB/DevOHCI.cpp	(revision 90332)
@@ -6024,5 +6024,5 @@
     if (RTCritSectIsInitialized(&pThisCC->CritSect))
         RTCritSectDelete(&pThisCC->CritSect);
-    PDMR3CritSectDelete(&pThis->CsIrq);
+    PDMDevHlpCritSectDelete(pDevIns, &pThis->CsIrq);
 
     /*
Index: trunk/src/VBox/Devices/VMMDev/VMMDev.cpp
===================================================================
--- trunk/src/VBox/Devices/VMMDev/VMMDev.cpp	(revision 90331)
+++ trunk/src/VBox/Devices/VMMDev/VMMDev.cpp	(revision 90332)
@@ -316,5 +316,5 @@
 {
     Log3(("vmmdevNotifyGuestWorker: fAddEvents=%#010x.\n", fAddEvents));
-    Assert(PDMCritSectIsOwner(&pThis->CritSect));
+    Assert(PDMDevHlpCritSectIsOwner(pDevIns, &pThis->CritSect));
 
     if (!VMMDEV_INTERFACE_VERSION_IS_1_03(pThis))
@@ -3183,5 +3183,5 @@
                 else
                 {
-                    Log(("vmmdevFastRequestHandler: PDMCritSectEnter -> %Rrc\n", rc2));
+                    Log(("vmmdevFastRequestHandler: PDMDevHlpPDMCritSectEnter -> %Rrc\n", rc2));
                     rcStrict = rc2;
                 }