Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardDiskEditors.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardDiskEditors.cpp	(revision 90361)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardDiskEditors.cpp	(revision 90362)
@@ -28,4 +28,5 @@
 #include "QILineEdit.h"
 #include "QIToolButton.h"
+#include "QIRichTextLabel.h"
 #include "UICommon.h"
 #include "UIConverter.h"
@@ -43,4 +44,17 @@
 #include "CSystemProperties.h"
 
+
+/*********************************************************************************************************************************
+*   UIDiskEditorGroupBox implementation.                                                                                   *
+*********************************************************************************************************************************/
+
+UIDiskEditorGroupBox::UIDiskEditorGroupBox(bool fExpertMode, QWidget *pParent /* = 0 */)
+    : QIWithRetranslateUI<QGroupBox>(pParent)
+    , m_fExpertMode(fExpertMode)
+{
+    if (!m_fExpertMode)
+        setFlat(true);
+}
+
 /*********************************************************************************************************************************
 *   UIDiskFormatsGroupBox implementation.                                                                                   *
@@ -48,7 +62,6 @@
 
 UIDiskFormatsGroupBox::UIDiskFormatsGroupBox(bool fExpertMode, QWidget *pParent /* = 0 */)
-    : QIWithRetranslateUI<QGroupBox>(pParent)
+    : UIDiskEditorGroupBox(fExpertMode, pParent)
     , m_pFormatButtonGroup(0)
-    , m_fExpertMode(fExpertMode)
 {
     prepare();
@@ -78,6 +91,4 @@
 {
     QVBoxLayout *pContainerLayout = new QVBoxLayout(this);
-    if (!m_fExpertMode)
-        setFlat(true);
 
     m_pFormatButtonGroup = new QButtonGroup;
@@ -212,8 +223,7 @@
 
 UIDiskVariantGroupBox::UIDiskVariantGroupBox(bool fExpertMode, QWidget *pParent /* = 0 */)
-    : QIWithRetranslateUI<QGroupBox>(pParent)
+    : UIDiskEditorGroupBox(fExpertMode, pParent)
     , m_pFixedCheckBox(0)
     , m_pSplitBox(0)
-    , m_fExpertMode(fExpertMode)
 {
     prepare();
@@ -222,6 +232,4 @@
 void UIDiskVariantGroupBox::prepare()
 {
-    if (!m_fExpertMode)
-        setFlat(true);
     QVBoxLayout *pVariantLayout = new QVBoxLayout(this);
     AssertReturnVoid(pVariantLayout);
@@ -353,11 +361,11 @@
 *********************************************************************************************************************************/
 
-UIMediumSizeAndPathGroupBox::UIMediumSizeAndPathGroupBox(QWidget *pParent /* = 0 */)
-    : QIWithRetranslateUI<QGroupBox>(pParent)
-    , m_pLocationLabel(0)
+UIMediumSizeAndPathGroupBox::UIMediumSizeAndPathGroupBox(bool fExpertMode, QWidget *pParent /* = 0 */)
+    : UIDiskEditorGroupBox(fExpertMode, pParent)
     , m_pLocationEditor(0)
     , m_pLocationOpenButton(0)
-    , m_pMediumSizeEditorLabel(0)
     , m_pMediumSizeEditor(0)
+    , m_pLocationLabel(0)
+    , m_pSizeLabel(0)
 {
     prepare();
@@ -366,9 +374,9 @@
 void UIMediumSizeAndPathGroupBox::prepare()
 {
-    QGridLayout *pDiskContainerLayout = new QGridLayout(this);
-
-    /* Disk location widgets: */
-    m_pLocationLabel = new QLabel;
-    m_pLocationLabel->setSizePolicy(QSizePolicy::Maximum, QSizePolicy::Fixed);
+    QVBoxLayout *pMainLayout = new QVBoxLayout(this);
+    /* Location widgets: */
+    if (!m_fExpertMode)
+        m_pLocationLabel = new QIRichTextLabel;
+    QHBoxLayout *pLocationLayout = new QHBoxLayout;
     m_pLocationEditor = new QILineEdit;
     m_pLocationOpenButton = new QIToolButton;
@@ -378,19 +386,20 @@
         m_pLocationOpenButton->setIcon(UIIconPool::iconSet(":/select_file_16px.png", "select_file_disabled_16px.png"));
     }
-    m_pLocationLabel->setBuddy(m_pLocationEditor);
-
-    /* Disk file size widgets: */
-    m_pMediumSizeEditorLabel = new QLabel;
-    m_pMediumSizeEditorLabel->setAlignment(Qt::AlignRight);
-    m_pMediumSizeEditorLabel->setSizePolicy(QSizePolicy::Minimum, QSizePolicy::Fixed);
+    pLocationLayout->addWidget(m_pLocationEditor);
+    pLocationLayout->addWidget(m_pLocationOpenButton);
+
+    /* Size widgets: */
+    if (!m_fExpertMode)
+        m_pSizeLabel = new QIRichTextLabel;
     m_pMediumSizeEditor = new UIMediumSizeEditor;
-    m_pMediumSizeEditorLabel->setBuddy(m_pMediumSizeEditor);
-
-    pDiskContainerLayout->addWidget(m_pLocationLabel, 0, 0, 1, 1);
-    pDiskContainerLayout->addWidget(m_pLocationEditor, 0, 1, 1, 2);
-    pDiskContainerLayout->addWidget(m_pLocationOpenButton, 0, 3, 1, 1);
-
-    pDiskContainerLayout->addWidget(m_pMediumSizeEditorLabel, 1, 0, 1, 1, Qt::AlignBottom);
-    pDiskContainerLayout->addWidget(m_pMediumSizeEditor, 1, 1, 2, 3);
+
+    /* Add widgets to main layout: */
+    if (m_pLocationLabel)
+        pMainLayout->addWidget(m_pLocationLabel);
+    pMainLayout->addLayout(pLocationLayout);
+
+    if (m_pSizeLabel)
+        pMainLayout->addWidget(m_pSizeLabel);
+    pMainLayout->addWidget(m_pMediumSizeEditor);
 
     connect(m_pMediumSizeEditor, &UIMediumSizeEditor::sigSizeChanged,
@@ -407,7 +416,16 @@
 void UIMediumSizeAndPathGroupBox::retranslateUi()
 {
-    setTitle(tr("Hard Disk File Location and Size"));
+    if (m_fExpertMode)
+        setTitle(tr("Hard Disk File Location and Size"));
     if (m_pLocationOpenButton)
         m_pLocationOpenButton->setToolTip(tr("Choose a location for new virtual hard disk file..."));
+
+    if (!m_fExpertMode && m_pLocationLabel)
+        m_pLocationLabel->setText(tr("Please type the name of the new virtual hard disk file into the box below or "
+                                                    "click on the folder icon to select a different folder to create the file in."));
+    if (!m_fExpertMode && m_pSizeLabel)
+        m_pSizeLabel->setText(tr("Select the size of the virtual hard disk in megabytes. "
+                                                "This size is the limit on the amount of file data "
+                                                "that a virtual machine will be able to store on the hard disk."));
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardDiskEditors.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardDiskEditors.h	(revision 90361)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardDiskEditors.h	(revision 90362)
@@ -37,4 +37,5 @@
 class QLabel;
 class QVBoxLayout;
+class QIRichTextLabel;
 class QILineEdit;
 class QIToolButton;
@@ -49,5 +50,18 @@
 #include "CMediumFormat.h"
 
-class SHARED_LIBRARY_STUFF UIDiskFormatsGroupBox : public QIWithRetranslateUI<QGroupBox>
+class SHARED_LIBRARY_STUFF UIDiskEditorGroupBox : public QIWithRetranslateUI<QGroupBox>
+{
+    Q_OBJECT;
+
+public:
+
+    UIDiskEditorGroupBox(bool fExpertMode, QWidget *pParent = 0);
+
+protected:
+
+    bool m_fExpertMode;
+};
+
+class SHARED_LIBRARY_STUFF UIDiskFormatsGroupBox : public UIDiskEditorGroupBox
 {
     Q_OBJECT;
@@ -78,8 +92,7 @@
     QStringList m_formatExtensions;
     QButtonGroup *m_pFormatButtonGroup;
-    bool m_fExpertMode;
 };
 
-class SHARED_LIBRARY_STUFF UIDiskVariantGroupBox : public QIWithRetranslateUI<QGroupBox>
+class SHARED_LIBRARY_STUFF UIDiskVariantGroupBox : public UIDiskEditorGroupBox
 {
     Q_OBJECT;
@@ -109,9 +122,8 @@
     QCheckBox *m_pFixedCheckBox;
     QCheckBox *m_pSplitBox;
-    bool m_fExpertMode;
 };
 
 
-class SHARED_LIBRARY_STUFF UIMediumSizeAndPathGroupBox : public QIWithRetranslateUI<QGroupBox>
+class SHARED_LIBRARY_STUFF UIMediumSizeAndPathGroupBox : public UIDiskEditorGroupBox
 {
     Q_OBJECT;
@@ -125,6 +137,5 @@
 public:
 
-    UIMediumSizeAndPathGroupBox(QWidget *pParent = 0);
-
+    UIMediumSizeAndPathGroupBox(bool fExpertMode, QWidget *pParent = 0);
     QString mediumPath() const;
     void setMediumPath(const QString &strMediumPath);
@@ -132,5 +143,4 @@
     qulonglong mediumSize() const;
     void setMediumSize(qulonglong uSize);
-
 
 private:
@@ -141,10 +151,9 @@
                                         const QStringList &formatExtensions);
 
-
-    QLabel *m_pLocationLabel;
     QILineEdit *m_pLocationEditor;
     QIToolButton *m_pLocationOpenButton;
-    QLabel *m_pMediumSizeEditorLabel;
     UIMediumSizeEditor *m_pMediumSizeEditor;
+    QIRichTextLabel *m_pLocationLabel;
+    QIRichTextLabel *m_pSizeLabel;
 };
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVD.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVD.cpp	(revision 90361)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVD.cpp	(revision 90362)
@@ -63,4 +63,5 @@
             addPage(new UIWizardNewVDPageFileType);
             addPage(new UIWizardNewVDPageVariant);
+            addPage(new UIWizardNewVDPageSizeLocation(m_strDefaultName, m_strDefaultPath, m_uDefaultSize));
             break;
         }
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageSizeLocation.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageSizeLocation.cpp	(revision 90361)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageSizeLocation.cpp	(revision 90362)
@@ -300,4 +300,5 @@
     QVBoxLayout *pMainLayout = new QVBoxLayout(this);
     AssertReturnVoid(pMainLayout);
+    m_pMediumSizePathGroup = new UIMediumSizeAndPathGroupBox(false, 0);
 //     {
 //         m_pLocationLabel = new QIRichTextLabel(this);
@@ -319,6 +320,6 @@
 //         pMainLayout->addLayout(pLocationLayout);
 //         pMainLayout->addWidget(m_pSizeLabel);
-//         pMainLayout->addWidget(m_pMediumSizeEditor);
-//         pMainLayout->addStretch();
+    pMainLayout->addWidget(m_pMediumSizePathGroup);
+    pMainLayout->addStretch();
 //     }
     retranslateUi();
@@ -334,11 +335,4 @@
 {
     setTitle(UIWizardNewVD::tr("File location and size"));
-    // if (m_pLocationLabel)
-    //     m_pLocationLabel->setText(UIWizardNewVD::tr("Please type the name of the new virtual hard disk file into the box below or "
-    //                                                 "click on the folder icon to select a different folder to create the file in."));
-    // if (m_pSizeLabel)
-    //     m_pSizeLabel->setText(UIWizardNewVD::tr("Select the size of the virtual hard disk in megabytes. "
-    //                                             "This size is the limit on the amount of file data "
-    //                                             "that a virtual machine will be able to store on the hard disk."));
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageVariant.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageVariant.cpp	(revision 90361)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageVariant.cpp	(revision 90362)
@@ -233,4 +233,4 @@
 {
     //return mediumVariant() != (qulonglong)KMediumVariant_Max;
-    return false;
-}
+    return true;
+}
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageExpert.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageExpert.cpp	(revision 90361)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageExpert.cpp	(revision 90362)
@@ -464,5 +464,5 @@
     QGridLayout *pDiskContainerLayout = new QGridLayout(pNewDiskContainerWidget);
 
-    m_pSizeAndLocationGroup = new UIMediumSizeAndPathGroupBox;
+    m_pSizeAndLocationGroup = new UIMediumSizeAndPathGroupBox(true, 0);
     pDiskContainerLayout->addWidget(m_pSizeAndLocationGroup, 0, 0, 2, 2);
     m_pFormatButtonGroup = new UIDiskFormatsGroupBox(true, 0);