Index: trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationObjects.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationObjects.cpp	(revision 90373)
+++ trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationObjects.cpp	(revision 90374)
@@ -21,4 +21,90 @@
 
 /*********************************************************************************************************************************
+*   Class UINotificationProgressMediumCreate implementation.                                                                     *
+*********************************************************************************************************************************/
+
+UINotificationProgressMediumCreate::UINotificationProgressMediumCreate(const CMedium &comTarget,
+                                                                       qulonglong uSize,
+                                                                       const QVector<KMediumVariant> &variants)
+    : m_comTarget(comTarget)
+    , m_uSize(uSize)
+    , m_variants(variants)
+{
+    connect(this, &UINotificationProgress::sigProgressFinished,
+            this, &UINotificationProgressMediumCreate::sltHandleProgressFinished);
+}
+
+QString UINotificationProgressMediumCreate::name() const
+{
+    return UINotificationProgress::tr("Creating medium ...");
+}
+
+QString UINotificationProgressMediumCreate::details() const
+{
+    return UINotificationProgress::tr("<b>Location:</b> %1<br><b>Size:</b> %2")
+                                     .arg(m_comTarget.GetLocation()).arg(m_uSize);
+}
+
+CProgress UINotificationProgressMediumCreate::createProgress(COMResult &comResult)
+{
+    /* Initialize progress-wrapper: */
+    CProgress comProgress = m_comTarget.CreateBaseStorage(m_uSize, m_variants);
+    /* Store COM result: */
+    comResult = m_comTarget;
+    /* Return progress-wrapper: */
+    return comProgress;
+}
+
+void UINotificationProgressMediumCreate::sltHandleProgressFinished()
+{
+    if (m_comTarget.isNotNull() && !m_comTarget.GetId().isNull())
+        emit sigMediumCreated(m_comTarget);
+}
+
+
+/*********************************************************************************************************************************
+*   Class UINotificationProgressMediumCopy implementation.                                                                       *
+*********************************************************************************************************************************/
+
+UINotificationProgressMediumCopy::UINotificationProgressMediumCopy(const CMedium &comSource,
+                                                                   const CMedium &comTarget,
+                                                                   const QVector<KMediumVariant> &variants)
+    : m_comSource(comSource)
+    , m_comTarget(comTarget)
+    , m_variants(variants)
+{
+    connect(this, &UINotificationProgress::sigProgressFinished,
+            this, &UINotificationProgressMediumCopy::sltHandleProgressFinished);
+}
+
+QString UINotificationProgressMediumCopy::name() const
+{
+    return UINotificationProgress::tr("Copying medium ...");
+}
+
+QString UINotificationProgressMediumCopy::details() const
+{
+    return UINotificationProgress::tr("<b>From:</b> %1<br><b>To:</b> %2")
+                                     .arg(m_comSource.GetLocation(), m_comTarget.GetLocation());
+}
+
+CProgress UINotificationProgressMediumCopy::createProgress(COMResult &comResult)
+{
+    /* Initialize progress-wrapper: */
+    CProgress comProgress = m_comSource.CloneTo(m_comTarget, m_variants, CMedium());
+    /* Store COM result: */
+    comResult = m_comSource;
+    /* Return progress-wrapper: */
+    return comProgress;
+}
+
+void UINotificationProgressMediumCopy::sltHandleProgressFinished()
+{
+    if (m_comTarget.isNotNull() && !m_comTarget.GetId().isNull())
+        emit sigMediumCopied(m_comTarget);
+}
+
+
+/*********************************************************************************************************************************
 *   Class UINotificationProgressMediumMove implementation.                                                                       *
 *********************************************************************************************************************************/
@@ -51,90 +137,4 @@
     /* Return progress-wrapper: */
     return comProgress;
-}
-
-
-/*********************************************************************************************************************************
-*   Class UINotificationProgressMediumCreate implementation.                                                                     *
-*********************************************************************************************************************************/
-
-UINotificationProgressMediumCreate::UINotificationProgressMediumCreate(const CMedium &comTarget,
-                                                                       qulonglong uSize,
-                                                                       const QVector<KMediumVariant> &variants)
-    : m_comTarget(comTarget)
-    , m_uSize(uSize)
-    , m_variants(variants)
-{
-    connect(this, &UINotificationProgress::sigProgressFinished,
-            this, &UINotificationProgressMediumCreate::sltHandleProgressFinished);
-}
-
-QString UINotificationProgressMediumCreate::name() const
-{
-    return UINotificationProgress::tr("Creating medium ...");
-}
-
-QString UINotificationProgressMediumCreate::details() const
-{
-    return UINotificationProgress::tr("<b>Location:</b> %1<br><b>Size:</b> %2")
-                                     .arg(m_comTarget.GetLocation()).arg(m_uSize);
-}
-
-CProgress UINotificationProgressMediumCreate::createProgress(COMResult &comResult)
-{
-    /* Initialize progress-wrapper: */
-    CProgress comProgress = m_comTarget.CreateBaseStorage(m_uSize, m_variants);
-    /* Store COM result: */
-    comResult = m_comTarget;
-    /* Return progress-wrapper: */
-    return comProgress;
-}
-
-void UINotificationProgressMediumCreate::sltHandleProgressFinished()
-{
-    if (m_comTarget.isNotNull() && !m_comTarget.GetId().isNull())
-        emit sigMediumCreated(m_comTarget);
-}
-
-
-/*********************************************************************************************************************************
-*   Class UINotificationProgressMediumCopy implementation.                                                                       *
-*********************************************************************************************************************************/
-
-UINotificationProgressMediumCopy::UINotificationProgressMediumCopy(const CMedium &comSource,
-                                                                   const CMedium &comTarget,
-                                                                   const QVector<KMediumVariant> &variants)
-    : m_comSource(comSource)
-    , m_comTarget(comTarget)
-    , m_variants(variants)
-{
-    connect(this, &UINotificationProgress::sigProgressFinished,
-            this, &UINotificationProgressMediumCopy::sltHandleProgressFinished);
-}
-
-QString UINotificationProgressMediumCopy::name() const
-{
-    return UINotificationProgress::tr("Copying medium ...");
-}
-
-QString UINotificationProgressMediumCopy::details() const
-{
-    return UINotificationProgress::tr("<b>From:</b> %1<br><b>To:</b> %2")
-                                     .arg(m_comSource.GetLocation(), m_comTarget.GetLocation());
-}
-
-CProgress UINotificationProgressMediumCopy::createProgress(COMResult &comResult)
-{
-    /* Initialize progress-wrapper: */
-    CProgress comProgress = m_comSource.CloneTo(m_comTarget, m_variants, CMedium());
-    /* Store COM result: */
-    comResult = m_comSource;
-    /* Return progress-wrapper: */
-    return comProgress;
-}
-
-void UINotificationProgressMediumCopy::sltHandleProgressFinished()
-{
-    if (m_comTarget.isNotNull() && !m_comTarget.GetId().isNull())
-        emit sigMediumCopied(m_comTarget);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationObjects.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationObjects.h	(revision 90373)
+++ trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationObjects.h	(revision 90374)
@@ -36,4 +36,92 @@
 #include "CVirtualSystemDescription.h"
 
+/** UINotificationProgress extension for medium create functionality. */
+class SHARED_LIBRARY_STUFF UINotificationProgressMediumCreate : public UINotificationProgress
+{
+    Q_OBJECT;
+
+signals:
+
+    /** Notifies listeners about @a comMedium was created. */
+    void sigMediumCreated(const CMedium &comMedium);
+
+public:
+
+    /** Constructs medium create notification-progress.
+      * @param  comTarget  Brings the medium being the target.
+      * @param  uSize      Brings the target medium size.
+      * @param  variants   Brings the target medium options. */
+    UINotificationProgressMediumCreate(const CMedium &comTarget,
+                                       qulonglong uSize,
+                                       const QVector<KMediumVariant> &variants);
+
+protected:
+
+    /** Returns object name. */
+    virtual QString name() const /* override final */;
+    /** Returns object details. */
+    virtual QString details() const /* override final */;
+    /** Creates and returns started progress-wrapper. */
+    virtual CProgress createProgress(COMResult &comResult) /* override final */;
+
+private slots:
+
+    /** Handles signal about progress being finished. */
+    void sltHandleProgressFinished();
+
+private:
+
+    /** Holds the medium being the target. */
+    CMedium                  m_comTarget;
+    /** Holds the target medium size. */
+    qulonglong               m_uSize;
+    /** Holds the target medium options. */
+    QVector<KMediumVariant>  m_variants;
+};
+
+/** UINotificationProgress extension for medium copy functionality. */
+class SHARED_LIBRARY_STUFF UINotificationProgressMediumCopy : public UINotificationProgress
+{
+    Q_OBJECT;
+
+signals:
+
+    /** Notifies listeners about @a comMedium was copied. */
+    void sigMediumCopied(const CMedium &comMedium);
+
+public:
+
+    /** Constructs medium copy notification-progress.
+      * @param  comSource  Brings the medium being copied.
+      * @param  comTarget  Brings the medium being the target.
+      * @param  variants   Brings the target medium options. */
+    UINotificationProgressMediumCopy(const CMedium &comSource,
+                                     const CMedium &comTarget,
+                                     const QVector<KMediumVariant> &variants);
+
+protected:
+
+    /** Returns object name. */
+    virtual QString name() const /* override final */;
+    /** Returns object details. */
+    virtual QString details() const /* override final */;
+    /** Creates and returns started progress-wrapper. */
+    virtual CProgress createProgress(COMResult &comResult) /* override final */;
+
+private slots:
+
+    /** Handles signal about progress being finished. */
+    void sltHandleProgressFinished();
+
+private:
+
+    /** Holds the medium being copied. */
+    CMedium                  m_comSource;
+    /** Holds the medium being the target. */
+    CMedium                  m_comTarget;
+    /** Holds the target medium options. */
+    QVector<KMediumVariant>  m_variants;
+};
+
 /** UINotificationProgress extension for medium move functionality. */
 class SHARED_LIBRARY_STUFF UINotificationProgressMediumMove : public UINotificationProgress
@@ -68,92 +156,4 @@
     /** Holds the final location. */
     QString  m_strTo;
-};
-
-/** UINotificationProgress extension for medium create functionality. */
-class SHARED_LIBRARY_STUFF UINotificationProgressMediumCreate : public UINotificationProgress
-{
-    Q_OBJECT;
-
-signals:
-
-    /** Notifies listeners about @a comMedium was created. */
-    void sigMediumCreated(const CMedium &comMedium);
-
-public:
-
-    /** Constructs medium create notification-progress.
-      * @param  comTarget  Brings the medium being the target.
-      * @param  uSize      Brings the target medium size.
-      * @param  variants   Brings the target medium options. */
-    UINotificationProgressMediumCreate(const CMedium &comTarget,
-                                       qulonglong uSize,
-                                       const QVector<KMediumVariant> &variants);
-
-protected:
-
-    /** Returns object name. */
-    virtual QString name() const /* override final */;
-    /** Returns object details. */
-    virtual QString details() const /* override final */;
-    /** Creates and returns started progress-wrapper. */
-    virtual CProgress createProgress(COMResult &comResult) /* override final */;
-
-private slots:
-
-    /** Handles signal about progress being finished. */
-    void sltHandleProgressFinished();
-
-private:
-
-    /** Holds the medium being the target. */
-    CMedium                  m_comTarget;
-    /** Holds the target medium size. */
-    qulonglong               m_uSize;
-    /** Holds the target medium options. */
-    QVector<KMediumVariant>  m_variants;
-};
-
-/** UINotificationProgress extension for medium copy functionality. */
-class SHARED_LIBRARY_STUFF UINotificationProgressMediumCopy : public UINotificationProgress
-{
-    Q_OBJECT;
-
-signals:
-
-    /** Notifies listeners about @a comMedium was copied. */
-    void sigMediumCopied(const CMedium &comMedium);
-
-public:
-
-    /** Constructs medium copy notification-progress.
-      * @param  comSource  Brings the medium being copied.
-      * @param  comTarget  Brings the medium being the target.
-      * @param  variants   Brings the target medium options. */
-    UINotificationProgressMediumCopy(const CMedium &comSource,
-                                     const CMedium &comTarget,
-                                     const QVector<KMediumVariant> &variants);
-
-protected:
-
-    /** Returns object name. */
-    virtual QString name() const /* override final */;
-    /** Returns object details. */
-    virtual QString details() const /* override final */;
-    /** Creates and returns started progress-wrapper. */
-    virtual CProgress createProgress(COMResult &comResult) /* override final */;
-
-private slots:
-
-    /** Handles signal about progress being finished. */
-    void sltHandleProgressFinished();
-
-private:
-
-    /** Holds the medium being copied. */
-    CMedium                  m_comSource;
-    /** Holds the medium being the target. */
-    CMedium                  m_comTarget;
-    /** Holds the target medium options. */
-    QVector<KMediumVariant>  m_variants;
 };
 