Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVD.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVD.cpp	(revision 90412)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVD.cpp	(revision 90413)
@@ -18,5 +18,4 @@
 /* GUI includes: */
 #include "UICommon.h"
-#include "UIMedium.h"
 #include "UIMessageCenter.h"
 #include "UINotificationCenter.h"
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageFileType.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageFileType.cpp	(revision 90412)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageFileType.cpp	(revision 90413)
@@ -18,5 +18,4 @@
 /* Qt includes: */
 #include <QVBoxLayout>
-#include <QButtonGroup>
 #include <QRadioButton>
 
@@ -25,22 +24,6 @@
 #include "UIWizardDiskEditors.h"
 #include "UIWizardNewVDPageFileType.h"
-#include "UIWizardNewVDPageSizeLocation.h"
 #include "UIWizardNewVD.h"
-#include "UICommon.h"
 #include "QIRichTextLabel.h"
-
-/* COM includes: */
-#include "CSystemProperties.h"
-
-// void UIWizardNewVDPageBaseFileType::setMediumFormat(const CMediumFormat &mediumFormat)
-// {
-//     int iPosition = m_formats.indexOf(mediumFormat);
-//     if (iPosition >= 0)
-//     {
-//         m_pFormatButtonGroup->button(iPosition)->click();
-//         m_pFormatButtonGroup->button(iPosition)->setFocus();
-//     }
-// }
-
 
 UIWizardNewVDPageFileType::UIWizardNewVDPageFileType()
@@ -49,14 +32,4 @@
 {
     prepare();
-    /* Create widgets: */
-
-    // /* Setup connections: */
-    // connect(m_pFormatButtonGroup, static_cast<void(QButtonGroup::*)(QAbstractButton*)>(&QButtonGroup::buttonClicked),
-    //         this, &UIWizardNewVDPageFileType::completeChanged);
-
-    // /* Register classes: */
-    // qRegisterMetaType<CMediumFormat>();
-    // /* Register fields: */
-    // registerField("mediumFormat", this, "mediumFormat");
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageFileType.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageFileType.h	(revision 90412)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageFileType.h	(revision 90413)
@@ -33,5 +33,4 @@
 }
 
-
 /* 1st page of the New Virtual Hard Drive wizard (basic extension): */
 class SHARED_LIBRARY_STUFF UIWizardNewVDPageFileType : public UINativeWizardPage
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageSizeLocation.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageSizeLocation.cpp	(revision 90412)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageSizeLocation.cpp	(revision 90413)
@@ -18,11 +18,5 @@
 /* Qt includes: */
 #include <QDir>
-#include <QRegExpValidator>
 #include <QVBoxLayout>
-#include <QHBoxLayout>
-#include <QLineEdit>
-#include <QSlider>
-#include <QLabel>
-#include <QSpacerItem>
 
 /* GUI includes: */
@@ -31,251 +25,8 @@
 #include "UICommon.h"
 #include "UIMessageCenter.h"
-#include "UIIconPool.h"
-#include "QIFileDialog.h"
-#include "QIRichTextLabel.h"
-#include "QIToolButton.h"
-#include "QILineEdit.h"
-#include "UIMediumSizeEditor.h"
 #include "UIWizardDiskEditors.h"
 
 /* COM includes: */
 #include "CSystemProperties.h"
-#include "CMediumFormat.h"
-
-/* Other VBox includes: */
-#include <iprt/cdefs.h>
-#include <iprt/path.h>
-
-
-// UIWizardNewVDPageBaseSizeLocation::UIWizardNewVDPageBaseSizeLocation(const QString &strDefaultName, const QString &strDefaultPath)
-//     : m_strDefaultName(strDefaultName.isEmpty() ? QString("NewVirtualDisk1") : strDefaultName)
-//     , m_strDefaultPath(strDefaultPath)
-//     , m_uMediumSizeMin(_4M)
-//     , m_uMediumSizeMax(uiCommon().virtualBox().GetSystemProperties().GetInfoVDSize())
-//     , m_pLocationEditor(0)
-//     , m_pLocationOpenButton(0)
-//     , m_pMediumSizeEditor(0)
-//     , m_pMediumSizeEditorLabel(0)
-//     , m_pLocationLabel(0)
-//     , m_pSizeLabel(0)
-// {
-// }
-
-// UIWizardNewVDPageBaseSizeLocation::UIWizardNewVDPageBaseSizeLocation()
-//     : m_uMediumSizeMin(_4M)
-//     , m_uMediumSizeMax(uiCommon().virtualBox().GetSystemProperties().GetInfoVDSize())
-//     , m_pLocationEditor(0)
-//     , m_pLocationOpenButton(0)
-//     , m_pMediumSizeEditor(0)
-//     , m_pMediumSizeEditorLabel(0)
-//     , m_pLocationLabel(0)
-//     , m_pSizeLabel(0)
-// {
-// }
-
-// void UIWizardNewVDPageBaseSizeLocation::onSelectLocationButtonClicked()
-// {
-//     /* Get current folder and filename: */
-//     QFileInfo fullFilePath(mediumPath());
-//     QDir folder = fullFilePath.path();
-//     QString strFileName = fullFilePath.fileName();
-
-//     /* Set the first parent folder that exists as the current: */
-//     while (!folder.exists() && !folder.isRoot())
-//     {
-//         QFileInfo folderInfo(folder.absolutePath());
-//         if (folder == QDir(folderInfo.absolutePath()))
-//             break;
-//         folder = folderInfo.absolutePath();
-//     }
-
-//     /* But if it doesn't exists at all: */
-//     if (!folder.exists() || folder.isRoot())
-//     {
-//         /* Use recommended one folder: */
-//         QFileInfo defaultFilePath(absoluteFilePath(strFileName, m_strDefaultPath));
-//         folder = defaultFilePath.path();
-//     }
-
-//     /* Prepare backends list: */
-//     QVector<QString> fileExtensions;
-//     QVector<KDeviceType> deviceTypes;
-//     CMediumFormat mediumFormat = fieldImp("mediumFormat").value<CMediumFormat>();
-//     mediumFormat.DescribeFileExtensions(fileExtensions, deviceTypes);
-//     QStringList validExtensionList;
-//     for (int i = 0; i < fileExtensions.size(); ++i)
-//         if (deviceTypes[i] == KDeviceType_HardDisk)
-//             validExtensionList << QString("*.%1").arg(fileExtensions[i]);
-//     /* Compose full filter list: */
-//     QString strBackendsList = QString("%1 (%2)").arg(mediumFormat.GetName()).arg(validExtensionList.join(" "));
-
-//     /* Open corresponding file-dialog: */
-//     QString strChosenFilePath = QIFileDialog::getSaveFileName(folder.absoluteFilePath(strFileName),
-//                                                               strBackendsList, thisImp(),
-//                                                               UICommon::tr("Please choose a location for new virtual hard disk file"));
-
-//     /* If there was something really chosen: */
-//     if (!strChosenFilePath.isEmpty())
-//     {
-//         /* If valid file extension is missed, append it: */
-//         if (QFileInfo(strChosenFilePath).suffix().isEmpty())
-//             strChosenFilePath += QString(".%1").arg(m_strDefaultExtension);
-//         if (m_pLocationEditor)
-//         {
-//             m_pLocationEditor->setText(QDir::toNativeSeparators(strChosenFilePath));
-//             m_pLocationEditor->selectAll();
-//             m_pLocationEditor->setFocus();
-//         }
-//     }
-// }
-
-// /* static */
-// QString UIWizardNewVDPageBaseSizeLocation::toFileName(const QString &strName, const QString &strExtension)
-// {
-//     /* Convert passed name to native separators (it can be full, actually): */
-//     QString strFileName = QDir::toNativeSeparators(strName);
-
-//     /* Remove all trailing dots to avoid multiple dots before extension: */
-//     int iLen;
-//     while (iLen = strFileName.length(), iLen > 0 && strFileName[iLen - 1] == '.')
-//         strFileName.truncate(iLen - 1);
-
-//     /* Add passed extension if its not done yet: */
-//     if (QFileInfo(strFileName).suffix().toLower() != strExtension)
-//         strFileName += QString(".%1").arg(strExtension);
-
-//     /* Return result: */
-//     return strFileName;
-// }
-
-// /* static */
-// QString UIWizardNewVDPageBaseSizeLocation::absoluteFilePath(const QString &strFileName, const QString &strPath)
-// {
-//     /* Wrap file-info around received file name: */
-//     QFileInfo fileInfo(strFileName);
-//     /* If path-info is relative or there is no path-info at all: */
-//     if (fileInfo.fileName() == strFileName || fileInfo.isRelative())
-//     {
-//         /* Resolve path on the basis of  path we have: */
-//         fileInfo = QFileInfo(strPath, strFileName);
-//     }
-//     /* Return full absolute hard disk file path: */
-//     return QDir::toNativeSeparators(fileInfo.absoluteFilePath());
-// }
-
-// /*static */
-// QString UIWizardNewVDPageBaseSizeLocation::absoluteFilePath(const QString &strFileName, const QString &strPath, const QString &strExtension)
-// {
-//     QString strFilePath = absoluteFilePath(strFileName, strPath);
-//     if (QFileInfo(strFilePath).suffix().isEmpty())
-//         strFilePath += QString(".%1").arg(strExtension);
-//     return strFilePath;
-// }
-
-// /* static */
-// QString UIWizardNewVDPageBaseSizeLocation::defaultExtension(const CMediumFormat &mediumFormatRef)
-// {
-//     if (!mediumFormatRef.isNull())
-//     {
-//         /* Load extension / device list: */
-//         QVector<QString> fileExtensions;
-//         QVector<KDeviceType> deviceTypes;
-//         CMediumFormat mediumFormat(mediumFormatRef);
-//         mediumFormat.DescribeFileExtensions(fileExtensions, deviceTypes);
-//         for (int i = 0; i < fileExtensions.size(); ++i)
-//             if (deviceTypes[i] == KDeviceType_HardDisk)
-//                 return fileExtensions[i].toLower();
-//     }
-//     AssertMsgFailed(("Extension can't be NULL!\n"));
-//     return QString();
-// }
-
-// /* static */
-// bool UIWizardNewVDPageBaseSizeLocation::checkFATSizeLimitation(const qulonglong uVariant, const QString &strMediumPath, const qulonglong uSize)
-// {
-//     /* If the hard disk is split into 2GB parts then no need to make further checks: */
-//     if (uVariant & KMediumVariant_VmdkSplit2G)
-//         return true;
-
-//     RTFSTYPE enmType;
-//     int rc = RTFsQueryType(QFileInfo(strMediumPath).absolutePath().toLatin1().constData(), &enmType);
-//     if (RT_SUCCESS(rc))
-//     {
-//         if (enmType == RTFSTYPE_FAT)
-//         {
-//             /* Limit the medium size to 4GB. minus 128 MB for file overhead: */
-//             qulonglong fatLimit = _4G - _128M;
-//             if (uSize >= fatLimit)
-//                 return false;
-//         }
-//     }
-
-//     return true;
-// }
-
-// QString UIWizardNewVDPageBaseSizeLocation::mediumPath() const
-// {
-//     if (!m_pLocationEditor)
-//         return QString();
-//     return absoluteFilePath(toFileName(m_pLocationEditor->text(), m_strDefaultExtension), m_strDefaultPath);
-// }
-
-// qulonglong UIWizardNewVDPageBaseSizeLocation::mediumSize() const
-// {
-//     return m_pMediumSizeEditor ? m_pMediumSizeEditor->mediumSize() : 0;
-// }
-
-// void UIWizardNewVDPageBaseSizeLocation::setMediumSize(qulonglong uMediumSize)
-// {
-//     if (m_pMediumSizeEditor)
-//         m_pMediumSizeEditor->setMediumSize(uMediumSize);
-// }
-
-// /* static */
-// QString UIWizardNewVDPageBaseSizeLocation::stripFormatExtension(const QString &strFileName, const QStringList &formatExtensions)
-// {
-//     QString result(strFileName);
-//     foreach (const QString &strExtension, formatExtensions)
-//     {
-//         if (strFileName.endsWith(strExtension, Qt::CaseInsensitive))
-//         {
-//             /* Add the dot to extenstion: */
-//             QString strExtensionWithDot(strExtension);
-//             strExtensionWithDot.prepend('.');
-//             int iIndex = strFileName.lastIndexOf(strExtensionWithDot, -1, Qt::CaseInsensitive);
-//             result.remove(iIndex, strExtensionWithDot.length());
-//         }
-//     }
-//     return result;
-// }
-
-// void UIWizardNewVDPageBaseSizeLocation::updateLocationEditorAfterFormatChange(const CMediumFormat &mediumFormat, const QStringList &formatExtensions)
-// {
-//     /* Compose virtual-disk extension: */
-//     m_strDefaultExtension = defaultExtension(mediumFormat);
-//     /* Update m_pLocationEditor's text if necessary: */
-//     if (!m_pLocationEditor->text().isEmpty() && !m_strDefaultExtension.isEmpty())
-//     {
-//         QFileInfo fileInfo(m_pLocationEditor->text());
-//         if (fileInfo.suffix() != m_strDefaultExtension)
-//         {
-//             QFileInfo newFileInfo(fileInfo.absolutePath(),
-//                                   QString("%1.%2").
-//                                   arg(stripFormatExtension(fileInfo.fileName(), formatExtensions)).
-//                                   arg(m_strDefaultExtension));
-//             m_pLocationEditor->setText(newFileInfo.absoluteFilePath());
-//         }
-//     }
-// }
-
-// void UIWizardNewVDPageBaseSizeLocation::retranslateWidgets()
-// {
-//     if (m_pLocationOpenButton)
-//         m_pLocationOpenButton->setToolTip(UIWizardNewVD::tr("Choose a location for new virtual hard disk file..."));
-
-
-//     if (m_pMediumSizeEditorLabel)
-//         m_pMediumSizeEditorLabel->setText(UIWizardNewVD::tr("D&isk Size:"));
-// }
 
 UIWizardNewVDPageSizeLocation::UIWizardNewVDPageSizeLocation(const QString &strDefaultName,
@@ -288,15 +39,4 @@
     , m_uDefaultSize(uDefaultSize)
 {
-
-
-
-//     /* Setup connections: */
-//     connect(m_pLocationEditor, &QLineEdit::textChanged,    this, &UIWizardNewVDPageSizeLocation::completeChanged);
-//     connect(m_pLocationOpenButton, &QIToolButton::clicked, this, &UIWizardNewVDPageSizeLocation::sltSelectLocationButtonClicked);
-//     connect(m_pMediumSizeEditor, &UIMediumSizeEditor::sigSizeChanged, this, &UIWizardNewVDPageSizeLocation::completeChanged);
-
-//     /* Register fields: */
-//     registerField("mediumPath", this, "mediumPath");
-//     registerField("mediumSize", this, "mediumSize");
     prepare();
 }
@@ -307,23 +47,4 @@
     AssertReturnVoid(pMainLayout);
     m_pMediumSizePathGroup = new UIMediumSizeAndPathGroupBox(false /* fExpertMode */, 0);
-//     {
-//         m_pLocationLabel = new QIRichTextLabel(this);
-//         QHBoxLayout *pLocationLayout = new QHBoxLayout;
-//         {
-//             m_pLocationEditor = new QLineEdit(this);
-//             m_pLocationOpenButton = new QIToolButton(this);
-//             {
-//                 m_pLocationOpenButton->setAutoRaise(true);
-//                 m_pLocationOpenButton->setIcon(UIIconPool::iconSet(":/select_file_16px.png", "select_file_disabled_16px.png"));
-//             }
-//             pLocationLayout->addWidget(m_pLocationEditor);
-//             pLocationLayout->addWidget(m_pLocationOpenButton);
-//         }
-//         m_pSizeLabel = new QIRichTextLabel(this);
-//         m_pMediumSizeEditor = new UIMediumSizeEditor;
-//         setMediumSize(uDefaultSize);
-//         pMainLayout->addWidget(m_pLocationLabel);
-//         pMainLayout->addLayout(pLocationLayout);
-//         pMainLayout->addWidget(m_pSizeLabel);
     connect(m_pMediumSizePathGroup, &UIMediumSizeAndPathGroupBox::sigMediumSizeChanged,
             this, &UIWizardNewVDPageSizeLocation::sltMediumSizeChanged);
@@ -340,7 +61,4 @@
 void UIWizardNewVDPageSizeLocation::sltSelectLocationButtonClicked()
 {
-    //m_userModifiedParameters
-    /* Call to base-class: */
-    //onSelectLocationButtonClicked();
 }
 
@@ -350,5 +68,4 @@
     m_userModifiedParameters << "MediumSize";
     newVDWizardPropertySet(MediumSize, m_pMediumSizePathGroup->mediumSize());
-
 }
 
@@ -367,13 +84,4 @@
 void UIWizardNewVDPageSizeLocation::initializePage()
 {
-    // /* Translate page: */
-
-
-    // /* Get default extension for new virtual-disk: */
-    // m_strDefaultExtension = defaultExtension(field("mediumFormat").value<CMediumFormat>());
-    // /* Set default name as text for location editor: */
-    // if (m_pLocationEditor)
-    //     m_pLocationEditor->setText(absoluteFilePath(m_strDefaultName, m_strDefaultPath, m_strDefaultExtension));
-
     UIWizardNewVD *pWizard = qobject_cast<UIWizardNewVD*>(wizard());
     AssertReturnVoid(pWizard && m_pMediumSizePathGroup);
@@ -437,12 +145,5 @@
     }
 
-    // /* Lock finish button: */
-    // startProcessing();
-    /* Try to create virtual-disk: */
     fResult = pWizard->createVirtualDisk();
-    // /* Unlock finish button: */
-    // endProcessing();
-
-    /* Return result: */
     return fResult;
 }
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageVariant.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageVariant.cpp	(revision 90412)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvd/UIWizardNewVDPageVariant.cpp	(revision 90413)
@@ -18,5 +18,4 @@
 /* Qt includes: */
 #include <QVBoxLayout>
-#include <QButtonGroup>
 
 /* GUI includes: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMDiskPageBasic.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMDiskPageBasic.cpp	(revision 90412)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMDiskPageBasic.cpp	(revision 90413)
@@ -19,9 +19,5 @@
 #include <QButtonGroup>
 #include <QCheckBox>
-#include <QDir>
-#include <QGridLayout>
-#include <QGroupBox>
 #include <QLabel>
-#include <QMetaType>
 #include <QRadioButton>
 #include <QVBoxLayout>
@@ -32,8 +28,8 @@
 #include "UIIconPool.h"
 #include "UIMediaComboBox.h"
-#include "UIMedium.h"
 #include "UIMediumSelector.h"
 #include "UIMediumSizeEditor.h"
 #include "UIMessageCenter.h"
+#include "UICommon.h"
 #include "UIWizardNewVMDiskPageBasic.h"
 #include "UIWizardDiskEditors.h"
@@ -41,10 +37,7 @@
 
 /* COM includes: */
+#include "COMEnums.h"
 #include "CGuestOSType.h"
 #include "CSystemProperties.h"
-
-/* Other VBox includes: */
-#include <iprt/path.h>
-
 
 QUuid UIWizardNewVMDiskPage::getWithFileOpenDialog(const QString &strOSTypeID,
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMDiskPageBasic.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMDiskPageBasic.h	(revision 90412)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMDiskPageBasic.h	(revision 90413)
@@ -29,5 +29,4 @@
 #include "QIFileDialog.h"
 #include "UINativeWizardPage.h"
-//
 
 /* COM includes: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMHardwarePageBasic.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMHardwarePageBasic.cpp	(revision 90412)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMHardwarePageBasic.cpp	(revision 90413)
@@ -17,7 +17,4 @@
 
 /* Qt includes: */
-#include <QCheckBox>
-#include <QGridLayout>
-#include <QMetaType>
 #include <QVBoxLayout>
 
@@ -25,10 +22,8 @@
 #include "QIRichTextLabel.h"
 #include "UIBaseMemoryEditor.h"
-#include "UIMessageCenter.h"
 #include "UIVirtualCPUEditor.h"
 #include "UIWizardNewVM.h"
 #include "UIWizardNewVMEditors.h"
 #include "UIWizardNewVMHardwarePageBasic.h"
-#include "UIWizardNewVDPageSizeLocation.h"
 
 /* COM includes: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMHardwarePageBasic.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMHardwarePageBasic.h	(revision 90412)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMHardwarePageBasic.h	(revision 90413)
@@ -24,29 +24,15 @@
 /* Qt includes: */
 #include <QSet>
-#include <QVariant>
 
 /* GUI includes: */
 #include "UINativeWizardPage.h"
 
-/* COM includes: */
-#include "COMEnums.h"
-#include "CMedium.h"
-
 /* Forward declarations: */
-class QRadioButton;
-class QCheckBox;
 class QIRichTextLabel;
-class UIBaseMemoryEditor;
 class UINewVMHardwareContainer;
-class UIVirtualCPUEditor;
-class UIWizardNewVM;
 
 namespace UIWizardNewVMHardwarePage
 {
 }
-//        int baseMemory() const;
-//        int VCPUCount() const;
-//        bool EFIEnabled() const;
-
 
 class UIWizardNewVMHardwarePageBasic : public UINativeWizardPage
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMNameOSTypePageBasic.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMNameOSTypePageBasic.cpp	(revision 90412)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMNameOSTypePageBasic.cpp	(revision 90413)
@@ -19,8 +19,4 @@
 #include <QCheckBox>
 #include <QDir>
-#include <QGridLayout>
-#include <QHBoxLayout>
-#include <QLabel>
-#include <QRadioButton>
 #include <QVBoxLayout>
 
@@ -28,5 +24,4 @@
 #include "QIRichTextLabel.h"
 #include "UICommon.h"
-#include "UIFilePathSelector.h"
 #include "UIMessageCenter.h"
 #include "UINameAndSystemEditor.h"
@@ -36,5 +31,4 @@
 /* COM includes: */
 #include "CHost.h"
-#include "CSystemProperties.h"
 #include "CUnattended.h"
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMNameOSTypePageBasic.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMNameOSTypePageBasic.h	(revision 90412)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMNameOSTypePageBasic.h	(revision 90413)
@@ -24,15 +24,9 @@
 /* Local includes: */
 #include "UINativeWizardPage.h"
-#include "UIExtraDataDefs.h"
 
 /* Forward declarations: */
-class QBoxLayout;
 class QCheckBox;
-class QFrame;
-class QLabel;
-class QRadioButton;
 class QGridLayout;
 class QIRichTextLabel;
-class UIFilePathSelector;
 class UINameAndSystemEditor;
 class UIWizardNewVM;
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageExpert.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageExpert.cpp	(revision 90412)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageExpert.cpp	(revision 90413)
@@ -19,27 +19,16 @@
 #include <QButtonGroup>
 #include <QCheckBox>
-#include <QGridLayout>
-#include <QGroupBox>
-#include <QHBoxLayout>
-#include <QLabel>
-#include <QLineEdit>
 #include <QRadioButton>
 #include <QVBoxLayout>
 
 /* GUI includes: */
-#include "QIRichTextLabel.h"
+#include "UICommon.h"
 #include "QIToolButton.h"
-#include "UIBaseMemoryEditor.h"
-#include "UIConverter.h"
-#include "UIHostnameDomainNameEditor.h"
-#include "UIFilePathSelector.h"
 #include "UIIconPool.h"
 #include "UIMediaComboBox.h"
 #include "UIMedium.h"
-#include "UIMediumSizeEditor.h"
 #include "UIMessageCenter.h"
 #include "UINameAndSystemEditor.h"
 #include "UIToolBox.h"
-#include "UIUserNamePasswordEditor.h"
 #include "UIWizardNewVM.h"
 #include "UIWizardDiskEditors.h"
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageExpert.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageExpert.h	(revision 90412)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageExpert.h	(revision 90413)
@@ -29,6 +29,6 @@
 #include "UIWizardNewVMDiskPageBasic.h"
 
-#include "COMEnums.h"
-#include "CMediumFormat.h"
+// #include "COMEnums.h"
+// #include "CMediumFormat.h"
 
 /* Forward declarations: */
@@ -36,24 +36,16 @@
 class QCheckBox;
 class QGridLayout;
-class QGroupBox;
-class QLabel;
-class QLineEdit;
 class QRadioButton;
-class QVBoxLayout;
 class QIToolButton;
 class UIAdditionalUnattendedOptions;
 class UIDiskFormatsGroupBox;
+class UIDiskVariantGroupBox;
 class UIMediumSizeAndPathGroupBox;
-class UIDiskVariantGroupBox;
-class UIFilePathSelector;
 class UIGAInstallationGroupBox;
-class UIHostnameDomainNameEditor;
 class UIMediaComboBox;
-class UIMediumSizeEditor;
 class UINameAndSystemEditor;
 class UINewVMHardwareContainer;
 class UIToolBox;
 class UIUserNamePasswordGroupBox;
-
 
 /** Expert page of the New Virtual Machine wizard. */
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMUnattendedPageBasic.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMUnattendedPageBasic.cpp	(revision 90412)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMUnattendedPageBasic.cpp	(revision 90413)
@@ -17,27 +17,12 @@
 
 /* Qt includes: */
-#include <QCheckBox>
 #include <QFileInfo>
 #include <QGridLayout>
-#include <QGroupBox>
-#include <QLabel>
-#include <QLineEdit>
-#include <QSpacerItem>
-#include <QVBoxLayout>
 
 /* GUI includes: */
 #include "QIRichTextLabel.h"
-#include "UICommon.h"
-#include "UIFilePathSelector.h"
-#include "UIIconPool.h"
 #include "UIWizardNewVMEditors.h"
-#include "UIHostnameDomainNameEditor.h"
 #include "UIWizardNewVMUnattendedPageBasic.h"
 #include "UIWizardNewVM.h"
-
-/* COM includes: */
-#include "CHost.h"
-#include "CSystemProperties.h"
-#include "CUnattended.h"
 
 bool UIWizardNewVMUnattendedPage::checkGAISOFile(const QString &strPath)
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMUnattendedPageBasic.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMUnattendedPageBasic.h	(revision 90412)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMUnattendedPageBasic.h	(revision 90413)
@@ -23,21 +23,11 @@
 
 /* Local includes: */
-#include "QIWithRetranslateUI.h"
 #include "UINativeWizardPage.h"
 
 /* Forward declarations: */
-class QCheckBox;
-class QGridLayout;
-class QGroupBox;
-class QLabel;
-class QLineEdit;
 class QIRichTextLabel;
 class UIAdditionalUnattendedOptions;
 class UIGAInstallationGroupBox;
-class UIFilePathSelector;
 class UIUserNamePasswordGroupBox;
-class UIHostnameDomainNameEditor;
-struct UIUnattendedInstallData;
-
 
 namespace UIWizardNewVMUnattendedPage